%Serie 10, Aufgabe 2, Numerische Mathematik FS 2014

%Lose Fehlergleichungen Ax-c=r
A=[1 2 0; -2 5 7; 3 -1 0; 4 0 -2];
c=[10;13;-5;1.8];

%a) mit Normalgleichungen
x = A'*A\(A'*c)


%b) mit QR-Zerlegung
[Q,R] = qr(A);
%System R_0 x = d_0, d=Q^T c to be solved:
n=size(A,2);
d=Q'*c;
x = R(1:n,:)\d(1:n)


%c) mit Singulaerwertzerlegung
[U,S,V] = svd(A);
k = rank(A);
y = zeros(k,1);
for i = 1:k
    y(i) = U(:,i)'*c/S(i,i);
end
x = V(:,1:k)*y